Subject: [sidr] rpki-rtr: caches announcing new serial numbers

From: Paul Hoffman <[email-masked]>
Date: Wed, 1 Jun 2011 09:17:54 -0700

Greetings again. Reading through the -12 draft and the mailing list archives, I cannot figure out what a cache is supposed to do when it has new data and thus a new serial number. Does it have to send a Serial Notify PDU? I'm pretty sure that the draft says all of "yes", "no", and "maybe" in different places. There should be one clear answer.

My personal choice would be "no" because the client router is already polling with Serial Query whenever it feels like it. In fact, it looks like Serial Notify can be completely eliminated and greatly simplify the implementation of the protocol, because then the protocol would be truly client-server with the client always initiating contact inside the transport. Yes, I know that it is late to redesign the protocol, but such a change is easy to make and would clarify the cache server's role significantly. The "do you have anything since serial number X" / "Nope" dance is very small, so I strongly suspect that even if a router client polls every minute, that traffic will be insignificant.

I question the need for "yes", given that a router is required to be polling anyway. I don't think that "maybe" makes sense at all, but could be convinced otherwise.

--Paul Hoffman

---

From: Randy Bush <[email-masked]>
Date: Wed, 01 Jun 2011 19:23:57 +0300

> Greetings again. Reading through the -12 draft and the mailing list
> archives, I cannot figure out what a cache is supposed to do when it
> has new data and thus a new serial number. Does it have to send a
> Serial Notify PDU? I'm pretty sure that the draft says all of "yes",
> "no", and "maybe" in different places. There should be one clear
> answer.

should be a MAY or a SHOULD.  read up on dns notify.

please point out where it is ambiguous and i will fix.

randy

---

From: Paul Hoffman <[email-masked]>
Date: Wed, 1 Jun 2011 09:54:58 -0700

On Jun 1, 2011, at 9:23 AM, Randy Bush wrote:

> should be a MAY or a SHOULD.  

There is a big difference. The WG should pick one (or none, if they like my idea of getting rid of "sometimes the server speaks without being spoken to").

What do you see as the purpose of "MAY" or "SHOULD", given that the client router is already polling as often as it likes (with a minimum of once an hour)?

> read up on dns notify.

Did that a very long time ago and a few times since then. Googling for it now shows how unclear it is to developers and users. :-(

> please point out where it is ambiguous and i will fix.

Section 4:
   When the cache updates its database, it sends a Notify message to
   every currently connected router.
Section 5.1:
   The cache notifies the router that the cache has new data.
Section 6.2:
     | -------- Notify ----------> |  (optional)
. . .
   The cache server SHOULD send a notify PDU with its current serial
   number when the cache's serial changes, with the expectation that the
   router MAY then issue a serial query earlier than it otherwise might.
   This is analogous to DNS NOTIFY in [RFC1996].  The cache SHOULD rate
   limit Serial Notifies to no more frequently than one per minute.

The first two indicates "MUST", the third indicates "MAY", the fourth indicates "SHOULD", but then modifies that with SHOULD-level rate limiting.

--Paul Hoffman

---

From: Randy Bush <[email-masked]>
Date: Wed, 01 Jun 2011 21:26:28 +0300

>> read up on dns notify. 
> Did that a very long time ago and a few times since then. Googling for
> it now shows how unclear it is to developers and users. :-(

it is why your dns updates propagate in a minute or two, not hours or
days.

randy